
static char *sccs_sid = "@(#)misc.c	1.10 4/26/88";

#include <stdio.h>
#include "browser.h"
#include "path.h"
#include <sys/types.h>
#include <sys/stat.h>

#define MAX_FILES 1000

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

char **entry_names = NULL;
long *entry_mod_times;

long date_of_mod (node)
/*  returns long indicating last date that node was modified  */
entries *node;
{   
    char *this_name, stemp [100];
    int indx;

    if (!entry_names)
    read_dates ();
    
    fprintf(stderr,"%s\n",entry_names);
    this_name = node -> name;
    for (indx = 0; entry_names [indx] && 
	strcmp (this_name, entry_names [indx]); indx++);
    if (entry_names [indx])
	return (entry_mod_times [indx]);
    sprintf (stemp, "File not found \"%s\"\n", this_name);
    rebuild_dates (stemp);
    return (date_of_mod (node));  /*  not found - why ? ? ? */

}


read_dates ()
{   FILE *f_dates;
    FILE *ftemp;
    long mod_date;
    char in_string [MAX_LINE], tmp_name [200], **ick;
    int indx;

    if (entry_names)
    {   for (ick = entry_names; *ick; ick++)
	    free (*ick);
	free (entry_names);
    }
    if (entry_mod_times)
	free (entry_mod_times);
    entry_names = entry_mod_times = NULL;

    if ((f_dates = fopen (DATE_FILE, "r")) == NULL)
    {   sprintf (tmp_name, "File not found \"%s\"\n",
	    DATE_FILE);
	rebuild_dates (tmp_name);
	if ((f_dates = fopen (DATE_FILE, "r")) == NULL)
	{   f_dates = (FILE *) -1;
	    printf ("Still couldn't get dates\n");
	    if ((ftemp = fopen (ERROR_FILE, "a")) == NULL)
		printf ("Administrator not notified\n");
	    else
	    {   fprintf (ftemp, "No date file could be made\n");
		fprintf (ftemp, "**********************\n");
		fclose (ftemp);
		printf ("Administrator notified.\n\n");
	    }
	}
    }

    entry_names = (char **) ecalloc (MAX_FILES, sizeof (char *));
    entry_mod_times = (long *) ecalloc (MAX_FILES, sizeof (long));

    indx = 0;
    while (fgets (in_string, MAX_LINE, f_dates) != NULL)
    {   sscanf (in_string, "%s%d", tmp_name, 
	    &(entry_mod_times [indx]));
	entry_names [indx] = (char *) new_string (tmp_name);
	indx++;
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

int inhibit_rebuild = 0;

rebuild_dates (reason)
/*  regenerate dates file  */
char *reason;
{   char **ick;

    if (inhibit_rebuild)
	return;   /*  disable auto date generation  */
    if (entry_names)
    {   for (ick = entry_names; *ick; ick++)
	    free (*ick);
	free (entry_names);
    }
    if (entry_mod_times)
	free (entry_mod_times);
    entry_names = entry_mod_times = NULL;
    printf ("\nRebuilding date file because:\n%s", reason);
    fflush (stdout);
    system (DATE_GENERATOR);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

mem_alloc (config)
/*  allocate some memory for things  */
entries ****config;
{   int indx, indx2;
    extern int silentbrowse, max_nest;

    if (!silentbrowse)
	printf ("Allocating memory ");  fflush (stdout);

/*  config holds each of the configuration levels  */
    *config = (entries ***) ecalloc (max_nest + 2, 
	sizeof (entries **));
/*  allocate memory for each of the nest levels  */
    for (indx = 0; indx <= max_nest; indx++)
    {   (*config) [indx] =  (entries **) ecalloc (MAX_ENTRIES + 2, 
	    sizeof (entries *));
/*  allocate memory for each of the entries  */
	for (indx2 = 0; indx2 < MAX_ENTRIES; indx2++)
	    (*config) [indx][indx2] = 
		(entries *) emalloc (sizeof (entries) + 2);
	if (!silentbrowse)  /*  put . for each level allocated  */
	    printf ("."); fflush (stdout);
    }
    if (!silentbrowse)
	printf (" done.\n\n");
}   /*  end of mem_alloc  */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */


get_answer (node)
/*  where to go from here ? ? ?  ask user  */
entries **node;
{   int num_nodes, itmp, indx;
    char resp [300], *resp_ptr, *prompt, *vec [MAX_ENTRIES], 
	stemp [300], *str_ptr;
    extern int X;

/*  find out how many nodes there are, and set up vector  */
    for (num_nodes = 1; node [num_nodes] -> type != '\0'; 
	num_nodes++)
    {   vec [num_nodes] = (char *) emalloc (MAX_DESCRIPTION);
	strcpy (vec [num_nodes], node [num_nodes] -> description);
	uc_string (vec [num_nodes]);
    }
    vec [0] = "QUIT";
    vec [num_nodes] = NULL;

    printf ("\n\n");
    do
    {	prompt = X ? 
	    "Number to go to, \"^\" to reset next window position" :
	    "Number to go to, \"^\" to back up";
	get_response (resp, prompt, "Quit");
	for (resp_ptr = resp; (*resp_ptr <= ' ') && 
	    (*resp_ptr != '\0'); resp_ptr++);
	switch (uc_char (*resp_ptr))
	{   case '^':
		itmp = NX_BACKUP;
		break;
	    case '!':
		resp_ptr++;
		do_shell (resp_ptr, node);
		itmp = NX_REDISPLAY;
		break;
	    case '0':  case '1':  case '2':  case '3':  case '4':
	    case '5':  case '6':  case '7':  case '8':  case '9':
		for (str_ptr = resp_ptr; ((*str_ptr >= '0') && 
		    (*str_ptr <= '9')); str_ptr++);
		if (*str_ptr <= ' ')  /*  first non-num is white */
		{   sscanf (resp_ptr, "%d", &itmp);
		    if ((itmp <= 0) || (itmp >= num_nodes))
			itmp = NX_INVALID;
		    if (itmp == NX_INVALID)
		    {	printf ("Invalid number, must be between ");
			printf ("1 and %d\n", num_nodes - 1);
		    }
		    break;
		}
/*  fall through to string search if no number given  */
	    default:  /*  any text entry  */
		uc_string (resp_ptr);  /*  for typing in the name  */
		sprintf (stemp, "^%s", resp_ptr);
/*  try at first of line - if not found, try anywhere in line  */
		if ((itmp = vdecode (stemp, vec)) < 0)
		    itmp = vdecode (resp_ptr, vec);
		if (itmp == -2)
		    printf ("String not found\n");
		else if (itmp == -1)
		    printf ("String not unique\n");
		if (itmp >= num_nodes)
		{   printf ("Invalid number, must be between ");
		    printf ("1 and %d\n", num_nodes - 1);
		}
		if ((itmp < 0) || (itmp >= num_nodes))
		    itmp = NX_INVALID;
		if (itmp == 0)  /*  QUIT  */
		    itmp = NX_QUIT;
		break;
	}
    }	while (itmp == NX_INVALID);
    for (indx = 0; indx < num_nodes; indx++)
	free (vec [num_nodes]);
    return (itmp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

