#ifndef LINT
static char *sccs_sid = "@(#)curs_help.c	2.3 5/15/89 WINLIB";
#endif

#include <stdio.h>
#include "curses.h"
#include "extern.h"
#include <ctype.h>

extern char HELP_DIRS [];

#define DEFAULT_EDITOR "vi"  
    /*  default editor to edit help files */


char *make_help_name (label, menu, retn)
char *label, *menu, *retn;
{   char xlabel [200], xmenu [200], *ptr;

    for (ptr = xlabel; *label; label++, ptr++)
	if (islower (*label))
	    *ptr = toupper (*label);
	else if (*label <= ' ')
	    *ptr = '-';
	else
	    *ptr = *label;
    *ptr = '\0';

    for (ptr = xmenu; *menu; menu++, ptr++)
	if (islower (*menu))
	    *ptr = toupper (*menu);
	else if (*menu <= ' ')
	    *ptr = '-';
	else
	    *ptr = *menu;
    *ptr = '\0';

    sprintf (retn, "%s%s%s", HELP_DIRS, xmenu, xlabel);
    return (retn);
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

static char *is_null (str)
char *str;
{   return (str ? str : "<NIL>");
}

/*STARTDOC*/
edit_help (label, menu)
char *label, *menu;
/*  try to edit help for label from directory menu  */
/*ENDDOC*/
{   char string [300], *editor, *getenv (), fname [200], *stmp;

    if (!(int)label || !(int)menu || !(int)HELP_DIRS)
    {   save_bottom ();
        move (LINES - 2, 0);
	sprintf (string, "Can\'t edit %s %s %s", is_null (HELP_DIRS),
	    is_null (menu), is_null (label));
	addstr (string);
	Pause (0);
	restore_bottom (NULL);
    }
    if (!(editor = getenv ("EDITOR")))
	editor = DEFAULT_EDITOR;

    sprintf (string, "%s \"%s\"", editor, 
	make_help_name (label, menu, fname));
    tty_mode ();
    printf ("\n%s\n", string);
    system (string);
    full_screen_mode ();
}


/*STARTDOC*/
displ_help (label, menu)
char *label, *menu;
/*  try to display help for label from directory menu  */
/*ENDDOC*/
{   int this_char, col_position, line;
    FILE *f_help, *find_help ();

    if (!(f_help = find_help (label, menu)))
    {   bell ();
	return;
    }

    save_bottom ();


    col_position = 1;
    line = 2;
    move (LINES - 2, 0);
    while ((this_char = fgetc (f_help)) != EOF)
    {   if ((this_char == '\n') || (col_position == COLS))
	{   clrtoeol ();
	    line--;
	    if (!line)
	    {   line = 2;
		refresh ();
		if (!feof (f_help))
		    Pause_x ();
		clean_bottom ();
	    }
	    move (LINES - line, 0);
	    clrtoeol ();
	    col_position = 1;
	}
	if ((this_char != '\n') && (this_char != EOF))
	{   col_position++;
	    addch (this_char);
	}
    }
    refresh ();
    if ((line != 2) || (col_position != 1))
	Pause_x ();
    restore_bottom (menu);
    fclose (f_help);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

Pause_x ()
{
    move (LINES - 1, COLS - 2);
    standout ();
    addstr ("+");
    standend ();
    move (LINES - 1, COLS - 3);
    get_key (stdscr);
    move (LINES - 1, COLS - 2);
    clrtoeol ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
FILE *find_help (label, menu)
char *label;
char *menu;
/*  Return file stream for label in menu.
    reference external variable HELP_DIR to find where
    to look below
    returns NULL if file can't be opened, if label or HELP_DIRS
    or menu are NULL, or if menu is the empty string
    (use "" for menu if there is to be no help for it
/*ENDDOC*/
{   char fname [400], *stmp;

    if (!(int)label || !(int)HELP_DIRS || !(int)menu || !(int)(*menu))
	return (NULL);

    return (fopen (make_help_name (label, menu, fname), "r"));
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

static char line_1 [300], line_2 [200];

/*STARTDOC*/
save_bottom ()
/*  stash the bottom two lines into a temp buffer  */
/*ENDDOC*/
{   int indx, cols_to_save;

    cols_to_save = (COLS <= 79) ? COLS : 79;
    cols_to_save -= 2;

    for (indx = 0; indx < cols_to_save; indx++)
    {   move (LINES - 2, indx);
        line_1 [indx] = inch ();
        move (LINES - 1, indx);
        line_2 [indx] = inch ();
    }
}

/*STARTDOC*/
restore_bottom (menu)
char *menu;
/*  restore buffer to the bottom lines.
    if menu != NULL, try to see if it should highlight the ``M''s
    at beginnings of lines.  Should look at standout, but it
    doesn't
*/
/*ENDDOC*/
{
    move (LINES - 2, 0);
    restore_x (line_1, menu);
    move (LINES - 1, 0);
    restore_x (line_2, menu);
}

restore_x (line, menu)
char *line;
char *menu;
{   if (menu && (*line == 'M'))
    {   line++;
	standout ();
	addch ('M');
	standend ();
    }
    addstr (line);
}


