#ifndef LINT
static char *sccs_sid = "@(#)name-expander.c	2.1 3/21/89 FAULKNLIB";
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/param.h>
#include <sys/file.h>
#include <strings.h>
#include <sys/stat.h>

#define MAXINDIRECT 2000
    /*  maximum number of names that the indirect name can
	be expanded to (like @/seq/nbrf-12/*.fls)
    */
extern int alphasort ();
    /*  so the entries are in alpha order  */

static name_part (), name_patch (), do_indirect ();

static dtest (d)
struct direct *d;
/*  tells if this entry should be part of the list  */
{   
    if (re_exec (d -> d_name) == 1)
    {
#ifdef DEBUG
	printf ("\"%s\"  ", d -> d_name);
#endif
        return (1);
    }
    else
	return (0);
}

/*STARTDOC*/
name_expander (inp, outlist)
char **inp, **outlist;
/*  expands the list from inp to outlist
    wild cards are expanded.
    uses the BSD re_exec package - WILL ZAP COMPILED PATTERNS ! ! !
    if file names begins with ``@'', it is an
	indirect file - a list of filespecs (recursive)
    if DATA environment set, and the file name does not begin
	with a ``.'' or a ``/'', then the file will be searched
	for ONLY in the directories specified in the DATA
	environment.
    DATA path elements WILL NOT BE WILD CARD EXPANDED ! ! !
*/
/*ENDDOC*/
{   char buf [MAXPATHLEN], buf2 [MAXPATHLEN],
	*getenv (), *DATA, *datap, *colon;
   
    DATA = getenv ("DATA");
    for (; *inp; inp++)
    {   if (**inp == '@')  /*  indirect  */
	{   (*inp)++;
	    do_indirect (*inp, &outlist);  
		/*  pass the name of indirect to the handler  */
	}
	else if (DATA && (**inp != '.') && (**inp != '/'))
/*  pick through the data environment - if ./ not in it: too bad! */
	{   for (datap = DATA; datap;)
	    {   strcpy (buf, datap);
		if (colon = index (buf, ':'))
		    *colon = '\0';
		if (datap = index (datap, ':'))
		    datap++;
		strcpy (buf2, *inp);
		if (*buf)  /*  empty string can't be part  */
		    name_part (buf, buf2, &outlist);
	    }
	}
	else
/* it is an absolute or restricted local search  */
        {   buf [0] = '\0';
	    if (**inp == '/')
	    {   (*inp)++;
		strcpy (buf, "/");
	    }
	    strcpy (buf2, *inp);
	    name_part (buf, buf2, &outlist);
	}
    }
}


/*STARTDOC*/
static name_part (front, iback, outlistp)
char *front, *iback;
char ***outlistp;
/*  front is a directory, iback is the remaining filespec
    file hits will be appended to outlist
    DIRECTORIES WILL NOT BE PUT INTO OUTLIST ! ! 
*/
/*ENDDOC*/
{   char *next_element, *re_result, re_buf [300], 
	*back, rback [MAXPATHLEN];
    struct direct **namelist;
    int num_found, indx;

#ifdef DEBUG
    printf ("\nnamepart \"%s\" \"%s\"\n", front, 
	iback ? iback : "<NULL>");
#endif
    if (!iback || !*iback)  /*  have full path when back is null  */
    {   if (!access (front, R_OK) && is_a_file (front))
	{   **outlistp = (char *) new_string (front);
	    (*outlistp)++;
	    **outlistp = NULL;
	}
	return;
    }

/*  have to copy the back - so the caller's copy doesn't get munged */
    strcpy (rback, iback);
    back = rback;

/*  next_element eats next element from back; back steps past it */
    next_element = back;
    back = index (back, '/');
    if (back)
    {	*back = '\0';
	back++;
    }

/*  convert from shell convention wild cards to regex convention
    escape the ``.''s
*/
    name_patch (next_element, re_buf);
    if (re_result = (char *) re_comp (re_buf))
/*  barf out if can't compile the regular expression  */
    {   
#ifdef DEBUG
	printf (stderr, "Bad RegEx: %s\n", re_result);
#endif
	**outlistp = NULL;
	return (1);
    }
    namelist = (struct direct **) 
	ecalloc (400, sizeof (struct direct *));
#ifdef DEBUG
    printf ("Running \"%s\" \"%s\" \"%s\"\n", front, re_buf,
	back ? back : "<NULL>");
#endif
    num_found = scandir (front, &namelist, dtest, alphasort);
/*  the compiled re is not used after this point  */
    for (next_element = front; *next_element; next_element++);
/*  next_element points to the end of the front  */
/*  zap a terminal ``/'' from the front (not if it is also start)  */
    if ((next_element != front) && (*(next_element - 1) != '/'))
    {   *next_element = '/';
	next_element++;
    }
/*  continue for all of the found elements  */
    for (indx = 0; indx < num_found; indx++)
    {   strcpy (next_element, namelist [indx] -> d_name);
/*  free the directory structures - we only needed the name,
	and we have copied it out  */
	free (namelist [indx]);
	if (back)  /*  there is more, front must be file  */
	{   if (is_a_dir (front))
/*  continue the search with the remaining back  */
		name_part (front, back, outlistp);
	}
	else  /*  back empty, front must be a file  */
	{   if (!access (front, R_OK) && is_a_file (front))
/*  add to list if it is a file and it can be read  */
	    {   **outlistp = (char *) new_string (front);
		(*outlistp)++;
		**outlistp = NULL;
	    }
	}
    }
    free (namelist);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

static name_patch (inp, outp)
/*  patch name to mimic shell wild card stuff  */
char *inp, *outp;
{   
/*  fudge to constrain to match beginning and end  */
/*  NO provision to repeat anything but ``.'' (* does this)  */
/*  ``NOT'' set is [^...] NOT [!...] as in ``sh''  */
    *outp = '^'; outp++;

    for (; *inp; inp++) 
    {   switch (*inp)
	{   case '.':  /*  literal .  */
		*outp = '\\'; outp++;
		*outp = '.'; outp++;
		break;
	    case '?':  /*  single wild  */
		*outp = '.'; outp++;
		break;
	    case '*':  /*  multiple wild  */
		*outp = '.'; outp++;
		*outp = '*'; outp++;
		break;
	    case '\\': /*  quote char  */
		*outp = '\\'; outp++; inp++;
		*outp = *inp; outp++;
		if (!*inp)
		    inp--;
		break;
	    default:
		*outp = *inp; outp++;
		break;
	}
    }

    *outp = '$'; outp++;
    *outp = '\0';
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   


/*STARTDOC*/
parse (name, list, delim, inc)
char *name, **list, delim;
int inc;
/*  no longer used in name_expander  */
/*ENDDOC*/
{   char buf [MAXNAMLEN], *ptr;

    if (!*name)
    {   *list = NULL;
	return;
    }

    ptr = buf;
    do
    {   if ((*name != delim) || inc)
	{   *ptr = *name;
	    ptr++; 
	}
	name++;
    }   while (*name && (*name != delim));
    if (*name)  /*  then it is a /  */
    {   if (inc)
	{   *ptr = *name;
	    ptr++; 
	}
	name++;
    }
    *ptr = '\0';
    *list = (char *) new_string (buf);
    list++;
    parse (name, list, delim, inc);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
is_a_file (name)
char *name;
/* returns 1 if ``name'' is a file, 0 if not  */
/*ENDDOC*/
{   struct stat sbuf;

    if (stat (name, &sbuf))
	return (0);
    return (sbuf.st_mode & S_IFREG);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
static do_indirect (name, outlistp)
char *name, ***outlistp;
/*  handle the indirect files  */
/*ENDDOC*/
{   FILE *finp;
    char buf [200], *fnames [MAXINDIRECT], *yuk [2];
    int indx;

    yuk [0] = name; yuk [1] = NULL;
/*  the filespec handed as an indirect will be expanded  */
    name_expander (yuk, fnames);
    for (indx = 0; fnames [indx]; indx++)
    {   if ((finp = fopen (fnames [indx], "r")) == NULL)
/*  should never happen . . .  */
	{   
#ifdef DEBUG
	    fprintf (stderr, "Bad indirect: \"%s\"", fnames [indx]);
	    perror (" because");
#endif
	    continue;
	}
	else 
	{   while (!feof (finp))
	    {   *buf = '\0';
/*STARTDOC*/
/*  BEWARE OF SPACES IN FILESPECS ! ! ! NO GO  */
/*ENDOC*/
		fscanf (finp, "%s", buf);
		yuk [0] = buf;
/*STARTDOC*/
/*  the individual elements will be expanded - so can be recursive */
/*ENDDOC*/
		name_expander (yuk, *outlistp);
/*  walk up the outlist  */
		while (**outlistp)
		    (*outlistp)++;
	    }
	    fclose (finp);
	}
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
is_a_dir (name)
char *name;
/* returns 1 if ``name'' is a file, 0 if not  */
/*ENDDOC*/
{   struct stat sbuf;

    if (stat (name, &sbuf))
	return (0);
    return (sbuf.st_mode & S_IFDIR);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
