#ifndef LINT
static char *sccs_sid = "@(#)open_file.c	2.1 3/21/89 FAULKNLIB";
#endif

#include "faulkn.h"

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
FILE *nread ();

FILE *open_file (name, o_mode)
/*  returns file pointer opened as requested
    name is default file name.  if name is null, user is prompted.
    name is modified to reflect the actual name of the file opened.
    if name is a non-empty string, an open will be attempted
	before user is prompted
    o_mode is "w" or "r" (only first letter significant);
    if o_mode is "r", user continually prompted till file opened.
    if o_mode is "w", user is asked whether to append or overwrite
        if file already exists.
    file name can be:
	1) a file name
	2) name of a pipe (first character is ``!'')
	3) network file (first character is ``:'',
	     and ``:'' separates host name from 
	     remote file name)
*/
char *name, *o_mode;
/*ENDDOC*/
{   FILE *ftemp;
    char *prompt, *internal_default, stemp [200], *mode_open, 
	junk [200], n_host [200], n_fname [200], *ick;
    int for_write, for_read, do_prompt, is_a_dev;
  
    do_prompt = (*name == '\0');
    for_write = (o_mode [0] == 'w');
    for_read = (o_mode [0] == 'r');
    if ((!for_write) && (!for_read))
    {   printf ("NOTIFY PROGRAMMER ! ! !\n");
        printf ("   \"INVALID O_MODE TO OPEN_FILE\"\n");
        printf ("ABORTING !\n");
        exit (1);
    }
    strcpy (junk, name);
    if (for_write) 
	prompt = "File to write to";
    else 
	prompt = "File to read from";
    if (name [0] != '\0') 
	internal_default = junk;
    else 
	internal_default = NULL;    
    ftemp = NULL;

    do
    {   if (do_prompt)
	    get_response (name, prompt, internal_default);
	do_prompt = 1;
	is_a_dev = (strncmp (name, "/dev/", 5) == 0);
        if (for_read)
	{   switch (*name)
	    {   case '!':
		    if (!(ftemp = popen (&(name [1]), "r")))
		    {   printf ("Cannot read from pipe %s\n",
			    &(name [1]));
			perror ("    because");
		    }
		    break;
		case ':':
		    strcpy (stemp, name);
		    for (ick = stemp; *ick; ick++)
			if (*ick == ':')
			    *ick = ' ';
		    *n_host = *n_fname = '\0';
		    sscanf (stemp, "%s%s", n_host, n_fname);
		    if (!*n_host || !*n_fname)
		    {   ftemp = NULL;
			printf ("Use :host:file_name for net access\n");
			break;
		    }
		    ftemp = nread (n_host, n_fname);
		    break;
		default:
		    /*  check for readability  */
		    if (access (name, 4) != 0) 
		    {   sprintf (stemp, "Cannot read file \"%s\"", 
			    name);
			perror (stemp);
		    }
	    /*  access says we can read file - try to open  */
		    else if ((ftemp = fopen (name, "r")) == NULL)
		    {   printf ("Cannot read file \"%s\"\n", name);
			perror ("    because");
		    }
		    break;
            }
        }
        else  /*  for writing  */
        {   switch (*name)
	    {   case ':':
		    printf ("No net file write allowed\n");
		    ftemp = NULL;
		    break;
		case '!':
		    if (!(ftemp = popen (&(name [1]), "w")))
		    {   printf ("Cannot write to pipe %s\n",
			    &(name [1]));
			perror ("    because");
		    }
		    break;
		default:
			  /*  check for exist  */
		    if (!is_a_dev && (access (name, 0) == 0))
/*  if file exists, does user want to overwrite, append, or reenter.
    default is to reenter if he types something strange */
		    {   get_response (stemp, 
			    "File exists: Overwrite, Append, Reenter,\n    or Backup",
			    "Append");
			uc_string (stemp);
			mode_open = NULL;
			if (member (stemp, "OVERWRITE", "O", NULL))
			    mode_open = "w";
			else if (member (stemp, "APPEND", "A", NULL))
			    mode_open = "a";
			else if (member (stemp, "BACKUP", "B", NULL))   {
			  if (backup_file (name))
			    mode_open = "w";
			  else
			    perror ("Could not backup file because");
			}
		/*  leave mode_open == NULL if file doesn't exist  */
		    }   else mode_open = "w";
	/*  default to plain "w" if file doesn't already exist  */
		    if (mode_open != NULL)
		    {   if ((ftemp = fopen (name, mode_open)) == NULL)
			    printf ("Cannot write to file \"%s\"\n", name);
		    }
		    break;
	    }
        }
	if (!ftemp && internal_default 
	    && !strcmp (internal_default, name))
		internal_default = NULL;
    }   while (ftemp == NULL);
    return (ftemp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

