#ifndef LINT
static char *sccs_sid = "@(#)regex-parse.c	2.1 3/21/89 FAULKNLIB";
#endif

#include <strings.h>
#include <stdio.h>

char regex_string [3000];

static char *get_nums (), *get_block ();
static apnd ();

/*STARTDOC*/
char *re_parse (src, dest)
char *src, *dest;
/*  parse the repeat factors from src to a gnu-emacs
    regex string in dest
    repeat factors are a la SystemV
*/
/*ENDDOC*/
{   char working [2000], *pos, *err, *end, *block,
	remainder [2000];
    int min_num, max_num, indx;

    strcpy (dest, src);
    while (pos = index (dest, '{'))
    {   end = pos;
	if (err = get_block (dest, pos - 1, working))
	    return (err);
	if (err = get_nums (&pos, &min_num, &max_num))
	    return (err);
	strcpy (remainder, pos);
	for (indx = 1; indx < min_num; indx++)
	    apnd (working, &end);
	if ((min_num < 1) || (max_num == -1))
	{   if (min_num < 1)
	    {   if (max_num == -1)
		    apnd ("*", &end);
		else
		    apnd ("?", &end);
	    }
	    else 
		apnd ("+", &end);
	}
	strcat (working, "?");
	for (; indx < max_num; indx++)
	    apnd (working, &end);
	apnd (remainder, &end);
    }
    return (NULL);
}


static char *get_block (start, end, working)
char *start, *end, *working;
{   int len, indx, indx2;
    char last, next_last;

    len = end - start;

    last = start [len];
    if (len == 0)
    {   if ((last == '*') || (last == '+') || (last == '?') 
	    || (last == '\\'))
	    return ("Repeat: bad expression");
	*working = last;
	working [1] = '\0';
	return (NULL);
    }
    next_last = start [len - 1];

    switch (last)
    {   case '|':
	    if (next_last == '\\')
		return ("Repeat: no second element for or");
	    *working = last;
	    working [1] = '\0';
	    return (NULL);
	    break;
	case '*':
	case '+':
	case '?':
	case '\\':
	    if (next_last != '\\')
		return ("Repeat: [*+?\\] followed by repeat");
	    *working = '\\';
	    working [1] = last;
	    working [2] = '\0';
	    return (NULL);
	case ')':
	    if (next_last != '\\')
	    {   *working = ')';
		working [1] = '\0';
		return (NULL);
		break;
	    }
	    indx2 = 1;
	    indx = len - 2;
	    while (indx2 && indx)
	    {   for (; (start [indx] != '\\') && indx; indx--);
		if (start [indx] == '\\')
		{   switch (start [indx + 1])
		    {   case '(':
			    indx2--;
			    break;
		        case ')':
			    indx2++;
			    break;
		    }
		}
	    }
	    if (indx2)
		return ("Repeat: no matching \\(");
	    for (indx2 = 0; indx2 + indx <= len; indx2++)
		working [indx2] = start [indx2 + indx];
	    working [indx2] = '\0';
	    return (NULL);
	    break;
	    
	case ']':
	    for (indx = len; (indx >= 0) && (start [indx] != '[');
		indx--);
	    if (start [indx] != '[')
		return ("Repeat: no matching [");
	    if ((indx >= 1) && (start [indx - 1] == '['))
		indx--;
	    for (indx2 = 0; indx2 + indx <= len; indx2++)
		working [indx2] = start [indx2 + indx];
	    working [indx2] = '\0';
	    return (NULL);
	    break;
	default:
	    if (next_last == '\\')
	    {   *working = '\\';
		working [1] = last;
		working [2] = '\0';
		return (NULL);
	    }
	    else
	    {   *working = last;
		working [1] = '\0';
		return (NULL);
	    }
	    break;
    }
}


static char *get_nums (str, minx, maxx)
char **str;
int *minx, *maxx;
{   char *a, *b;

    a = b = "-1";
    *minx = *maxx = -1;
    (*str)++; /*  step past {  */
    sscanf (*str, "%d", minx);
    while ((**str >= '0') && (**str <= '9'))
	(*str)++;
    if (**str != ',')
    {   if (**str == '}')
	{   (*str)++;
	    if (*minx == -1)
		*minx = 1;
	    *maxx = *minx;
	    return (NULL);
	}
	return ("Error in repeat factor");
    }
    (*str)++;
    sscanf (*str, "%d", maxx);
    while ((**str >= '0') && (**str <= '9'))
	(*str)++;
    if (**str != '}')
        return ("Bad char in repeat factor");
    (*str)++;
    return (NULL);
}


static apnd (what, where)
char *what, **where;
{
    for (; *what; what++, (*where)++)
	**where = *what;
    **where = '\0';
}
