#ifndef LINT
static char *sccs_sid = "@(#)vars.c	2.1 3/21/89 WINLIB";
#endif

#include <stdio.h>
#include "curses.h"
#include <sys/file.h>
#include "win-types.h"
#include "extern.h"

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

char *new_string ();


int ignore_var_errors = 0;
/*STARTDOC*/
set_variable ()
/*  Set a variable interactively  */
/*ENDDOC*/
{   char stemp [200], **boolean_list, stemp2 [300];
    int which_var, tmp_boolean, last_menu;
    static char
	*boolean_lista [] = { "ON", "OFF", NULL },
	*boolean_listb [] = { "OFF", "ON", NULL };
    var_node *this_var;

    if (which_var = win_prompt (stdscr, LINES - 2, "Set what", 
       (char *) NULL, variable_names, 1, "Variables/"))
    {   this_var = variables [which_var];
	set_history (this_var);
	switch (this_var -> v_type)
	{   case V_INTEGER:
		win_prompt (stdscr, LINES - 1, "    Set to (integer)", 
		    stemp, this_var -> history, 0, "Variables-Set-Integer");
		*(this_var -> strg.i) = str_to_number (stemp);
		break;
	    case V_BOOLEAN:
		boolean_list = *(this_var -> strg.b) ? 
		    boolean_lista : boolean_listb;
		tmp_boolean = !win_prompt (stdscr, LINES - 1, 
		    "    Set to (boolean)", stemp, 
		    boolean_list, 1,
		    "Variables-Set-Boolean/");
		*(this_var -> strg.b) = *(this_var -> strg.b) ?
		    tmp_boolean : !tmp_boolean;
		break;
	    case V_FLOAT:
		win_prompt (stdscr, LINES - 1, "    Set to (float)", 
		    stemp, this_var -> history, 0, "Variables-Set-Float");
		sscanf (stemp, "%f", this_var -> strg.f);
		break;
	    case V_STRING:
		win_prompt (stdscr, LINES - 1, "    Set to (string)", 
		    this_var -> strg.s, this_var -> history, 0,
		    "Variables-Set-String");
		break;
	    case V_NONE:
		break;
	    default:
		move (LINES - 2, 0);
		printw ("Unknown variable type %d", 
		    this_var -> v_type);
		Pause (1);
		break;
	}
	(*(this_var -> hook)) ();
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

char *SYSTEM_RC = NULL;

/*STARTDOC*/
var_initialize (argv)
char **argv;
/*  initialize variable values from command tail (get pgm name)
	and init files (systemrc and user's)
*/
/*ENDDOC*/
{   char file_name [500], *home, stemp [500], *getenv (), *index ();
    char **keep_argv, *equals;
    int temp_ignore_var_errors;

    temp_ignore_var_errors = ignore_var_errors;
    ignore_var_errors = 1;

    keep_argv = argv;
    if (SYSTEM_RC && !access (SYSTEM_RC, R_OK))
    {   clean_bottom ();
        read_var_file (SYSTEM_RC);
    }
    if (home = getenv ("HOME"))
    {   getcwd (stemp, 0);
        if (strcmp (stemp, home) != 0)
        /*  don't source home if already there  */
        {   sprintf (file_name, "%s/.%s-vars", home, *argv);
            if (!access (file_name, R_OK))
            {   clean_bottom ();
                read_var_file (file_name);
            }
        }
    }
    sprintf (file_name, ".%s-vars", *argv);
    if (!access (file_name, R_OK))
    {   clean_bottom ();
        read_var_file (file_name);
    }

    for (argv++, keep_argv++; *argv; argv++)
    {   if (equals = index (*argv, '='))
	{   *equals = '\0';
	    equals++;
	    text_set_variable (*argv, equals);
	}
	else
	{   *keep_argv = *argv;
	    keep_argv++;
	}
    }
    *keep_argv = NULL;
    ignore_var_errors = temp_ignore_var_errors;
}


/*STARTDOC*/
read_var_file (name)
char *name;
/*  read a file containg ``VARNAME'' ``VALUE'' on each line
    if ``ignore_var_errors'', errors silently ignored; else,
	print error message
*/
/*ENDDOC*/
{   FILE *finp;
    char buf [500], var1 [100], var [100], val1 [200], val [200],
	*equals;

    move (LINES - 3, 0);
    clrtobot ();
    if (!(finp = fopen (name, "r")))
    {   move (LINES - 2, 0);
	printw ("Could not read variable file \"%s\"", name);
	Pause (1);
	return;
    }
    move (LINES - 3, 0);
    printw ("Reading variable file \"%s\"", name);
    clrtoeol ();
    refresh ();
    while (fgets (buf, 500, finp))
        if (*buf && (*buf != '#'))
	{   sscanf (buf, "%s%*[ 	]%[^\n]", var1, val1);
	    string_convert (var1, var);
	    string_convert (val1, val);
	    text_set_variable (var, val);
	}
    fclose (finp);
    move (LINES - 3, 0);
    clrtobot ();
}


/*STARTDOC*/
text_set_variable (var_name, valu)
char *var_name, *valu;
/*  Set variable referenced by var_name to a value intended
	by the text string valu.
    invoke variable hook if necessary
/*ENDDOC*/
{   int which_var, len;
    var_node *this_var;

    len = strlen (var_name);
    for (which_var = 0; variable_names [which_var] && 
	Jstrncmp (var_name, variable_names [which_var], len);
	which_var++);
    if (!variable_names [which_var])
	which_var = -2;
    switch (which_var)
    {   case -2:
	    if (!ignore_var_errors)
	    {   move (LINES - 2, 0);
		printw ("Variable \"%s\" unknown", var_name);
		Pause (1);
	    }
	    break;
	case -1:
	    if (!ignore_var_errors)
	    {   move (LINES - 2, 0);
		printw ("Variable \"%s\" ambiguous", var_name);
		Pause (1);
	    }
	    break;
	default:
	    this_var = variables [which_var];
	    switch (this_var -> v_type)
	    {   case V_INTEGER:
		    *(this_var -> strg.i) = str_to_number (valu);
		    break;
		case V_FLOAT:
		    sscanf (valu, "%f", this_var -> strg.f);
		    break;
		case V_STRING:
		    strcpy (this_var -> strg.s, valu);
		    break;
		case V_BOOLEAN:
		    uc_string (valu);
		    switch (decode (valu, "OFF", "ON", NULL))
		    {   case 0:
			   *(this_var -> strg.b) = 0;
			   break;
		        case 1:
			   *(this_var -> strg.b) = 1;
			   break;
		    }
		    break;
		case V_NONE:
		    break;
		default:
		   move (LINES - 2, 0);
		   printw ("Unknown type for variable \"%s\"", var_name);
		   Pause (1);
		   break;
	    }
	    set_history (this_var);
	    if (which_var >= 0)
		(*(this_var -> hook)) ();
	    break;
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

/*STARTDOC*/
var_node *find_var (name)
char *name;
/*  Return pointer to variable node that has var name
    name must match EXACTLY
    if no match, return NULL
*/
/*ENDDOC*/
{   int indx;
    var_node *this;

    for (indx = 0; this = variables [indx]; indx++)
	if (!Jstrcmp (name, this -> name))
	    return (this);
    return (NULL);
}


set_history (this_var)
var_node *this_var;
{   char stemp [300];
    char **histry;
    int indx;

    if (!(histry = this_var -> history))
	return;
    *stemp = '\0';
    switch (this_var -> v_type)
    {   case V_INTEGER:
	    sprintf (stemp, "%d", *(this_var -> strg.i));
	    break;
	case V_FLOAT:
	    sprintf (stemp, "%f", *(this_var -> strg.f));
	    break;
	case V_STRING:
	    if (!*(this_var -> strg.s))
		strcpy (stemp, this_var -> strg.s);
	    break;
    }
    if (*stemp)
    {   for (indx = -1; histry [indx + 1]; indx++);
	if (indx >= 0)
	{   if (strcmp (histry [indx], stemp))
		histry [indx + 1] = new_string (stemp);
	}
	else
	    histry [0] = new_string (stemp);
    }
}
