#ifndef LINT
static char *sccs_sid = "@(#)bind.c	1.1 4/19/89 MASE";
#endif

#define MAX_MAP_EXPANSION 4000

#include "edseq.h"
#include "extern.h"
#include "extern2.h"
#include "../lib/win-types.h"

static macro_recurse ();

prefix_block *new_prefix ();
prefix_block *insert_prefix ();
prefix_block *prefix_lookup ();

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*ENDDOC*/
bind_all_alpha ()
/*  interactively bind a key to a function  */
/*ENDDOC*/
{   char stemp [200];
    unsigned key, key2;
    int ftn, IsPrefix, indx;
    prefix_block *ptr, *old_ptr, *new_next;

    IsPrefix = 0;
    move (LINES - 2, 0);
    addstr ("Bind starting with what key -> ");
    clrtoeol ();
    key = get_key (stdscr);
    ascii_print (key);
    if (short_cmd_pointers [key] == prefix)  {
	IsPrefix = 1;
	ptr = prefix_lookup (prefix_top, key);
	if (!ptr)  {
	    printw (" NO PREFIX");
	    putchar (7);
	    Pause (0);
	}
	do  {
	    old_ptr = ptr;
	    key = get_key (stdscr);
	    ascii_print (key);
	    if (ptr -> nest)
		ptr = prefix_lookup (ptr -> nest, key);
	}   while (ptr && (ptr -> nest));
	if (!ptr)
	    ptr = insert_prefix (old_ptr -> nest, key);
    }
    if ((key & 0x1f) != ('A' & 0x1f))  {
	move (LINES - 2, 0);
	printw ("Can only bind starting at a modification of \"A\"");
	Pause (0);
	return;
    }
    if (ftn = win_prompt (stdscr, LINES - 2, "Function to bind",
	stemp, long_cmd_names, 1, "Functions/"))  {
	if (long_cmd_pointers [ftn] == prefix)  {
	    move (LINES - 2, 0);
	    printw ("Cannot Bind-All-Alpha to PREFIX");
	    Pause (0);
	    return;
	}
	if (IsPrefix)  {
	   ptr -> function = long_cmd_pointers [ftn];
	   for (indx = 'B', key++; indx <= 'Z'; indx++, key++)  {
	       ptr = insert_prefix (prefix, key);
	       ptr -> function = long_cmd_pointers [ftn];
	   }
	}
	else  {
	    for (indx = 'A'; indx <= 'Z'; indx++, key++)
		short_cmd_pointers [key] = long_cmd_pointers [ftn];
	}
    }
}   


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   


/*STARTDOC*/
tbind_all_alpha (chr, ftn_name)
unsigned char *chr;
char *ftn_name;
/*  establish binding for ``chr'' key code to ``fnt_name''  */
/*ENDDOC*/
{   int indx;
    int (*ftn) ();
    prefix_block *ptr, *last;
    unsigned char start_char, *cptr;

    if (!(*chr) || !(*ftn_name))
	return;

    for (cptr = chr; cptr [1]; cptr++);
    start_char = *cptr;
    
    if ((start_char & 0x1f) != ('A' & 0x1f))  {
	move (LINES - 2, 0);
	printw ("Can only bind starting at a modification of \"A\"");
	Pause (0);
	return;
    }

    switch (indx = svdecode (ftn_name, long_cmd_names))
    {   case -2:   /*  not found  */
            e_printf ("Function \"%s\" unknown", ftn_name);
	    break;
        case -1:   /*  ambiguous  */
	    e_printf ("Function \"%s\" ambiguous", ftn_name);
	    break;
	default:
	    ftn = long_cmd_pointers [indx];
	    if (ftn == prefix)  {
		move (LINES - 2, 0);
		printw ("Cannot Bind-All-Alpha to PREFIX");
		Pause (0);
		return;
	    }
	    if (!chr [1])  {
		for (indx = 'A'; indx <= 'Z'; indx++, start_char++)
		    short_cmd_pointers [start_char] = ftn;
	    }
	    else  {
		if (short_cmd_pointers [*chr] != prefix)  {
	            short_cmd_pointers [*chr] = prefix;
		    ptr = insert_prefix (prefix_top, *chr);
		    ptr -> function = prefix;
		    ptr -> nest = new_prefix ();
		    ptr = ptr -> nest;
	        }
		ptr = prefix_top;
		while (chr [1])  {
		    last = ptr;
		    ptr = prefix_lookup (ptr, *chr);
		    if (!ptr)
		        ptr = insert_prefix (last, *chr);
		    if (!ptr -> nest)
		        ptr -> nest = new_prefix ();
		    ptr -> function = prefix;
		    ptr = ptr -> nest;
		    chr++;
		}
		for (indx = 'A'; indx <= 'Z'; indx++, start_char++)  {
		    ptr = insert_prefix (ptr, start_char);
		    ptr -> function = ftn;
		}
	    }
      	    break;
    }
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

