#ifndef LINT
static char *sccs_sid = "@(#)commands2.c	1.34 3/22/89 MASE ";
#endif

#include "edseq.h"
#include "extern.h"
#include "path.h"
#include "../lib/faulkn.h"

int *string_to_numbers ();

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

gripe ()
{   char buf [200];

    tty_mode ();
    printf ("Terminate gripe with ^D\n"); 
    sprintf (buf, "mail -s mase-gripes %s", MASE_ADMINISTRATOR);
    system (buf);
    full_screen_mode ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

static char *char_set_hist [300] = { "DEFAULT" };

do_char_set ()
/*  read in a new display character set  */
{   char stemp [200];

    win_prompt (stdscr, LINES - 2, "File containing character set",
	stemp, char_set_hist, 0, "Char-Set-File");
    read_char_set_file (stemp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

read_char_set_file (fname)
char *fname;
{   char stemp [200], *ptr, *new_string ();
    FILE *finp;

    display_alt = 1;  /*  set variable to make sure alt char set is
			  displayed  */
    if (strcmp (fname, "DEFAULT") == 0)
    {   default_char_set ();
	disp_all ();
	return;
    }
    if ((*fname == 0) || ((finp = 
	w_open_file (fname, "r", char_set_hist)) == NULL))
    {   move (LINES - 2, 0);
	clrtoeol ();
	printw ("Could not read character set file \"%s\"", fname);
	Pause (0);
	return;
    }
/*  arrive here if we are to read in the file  */
    default_char_set ();
    /*  set to all default values  */
    while (fgets (stemp, 200, finp))
    {   if ((*stemp != '\t') && (*stemp != '\n') && (*stemp != '\0'))
	{    ptr = stemp;
	    for (ptr++; *ptr; ptr++)
		char_set [*ptr] = *stemp;
	}
    }
    fclose (finp);
    disp_all ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

default_matrix ()
{   int indx;

    for (indx = 0; indx < 128; indx++)  {
      if (score_matrix [indx])  /*  already allocated  */
	bzero ((char *) score_matrix [indx], 128 * sizeof (float));
      else
/*  calloc init to zero  */
        score_matrix [indx] = (float *) ecalloc (129, sizeof (float));
    }

/*  set identities to 1.0  */
    for (indx = 0; indx < 128; indx++)
     	score_matrix [indx][indx] = 1.0;
	    /*  all others are set to 0.0  */
    
/*  leave gap x position at 0.0  */
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

default_char_set ()
{   int indx;

    for (indx = 0; indx < 128; indx++)
	char_set [indx] = indx;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

file_move (current_y)
int *current_y;
{   int *sq_list, *iptr;
    char stemp [200], **sptr;
    static char *move_which [200] = { NULL };
    static char *to_file [200];

    for (sptr = move_which; *sptr; sptr++);
    sprintf (stemp, "%d", *current_y + 1);
    *sptr = new_string (stemp);

    win_prompt (stdscr, LINES - 2, "Move which sequences", stemp,
	move_which, 0, "FMove-Which");
    if (!(sq_list = string_to_numbers (stemp)))
	return;

    win_prompt (stdscr, LINES - 2, "Move to which file", 
	stemp, to_file, 0, "FMove-Where");
    if (!*stemp)
    {    move (LINES - 2, 0);
	 addstr ("MOVE command aborted");
	 Pause (0);
    }
    for (iptr = sq_list; (*iptr >= 0); iptr++)
        if (*iptr)  /*  can't move consensus sequence  */
        {   file_dirty (entry [*iptr - 1] -> from_file);
	    strcpy (entry [*iptr - 1] -> from_file, stemp);
	}
    file_dirty (stemp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

zap_sequences (current_y, current_x, mult)
int *current_x, *current_y, mult;
{   static char *forwhich [200];
    char stemp [200];
    int *list, ix, ctr, *tmp, del;
    static char *listx [] = { "YES", "NO", NULL };

    i_d_doitx (forwhich, *current_y + 1, mult);
    win_prompt (stdscr, LINES - 2, "Zap which sequences",
	stemp, forwhich, 0, "Range");
    if (!(list = string_to_numbers (stemp)))
        return;
    ctr = 0;
    for (ix = 1; ix <= num_entries; ix++)
    {   del = 0;
        for (tmp = list; *tmp >= 0; tmp++)
       	    if (ix == *tmp)
		del = 1;
	if (del)
	{   move (LINES - 2, 0);
	    sprintf (stemp, "Locus # %d, ``%s\'\'", ix, 
		entry [ix - 1] -> locus_name);
	    addstr (stemp);
	    clrtoeol ();
	    del = !win_prompt (stdscr, LINES - 1, "Really delete it",
		stemp, listx, 1, "Really-Delete/");
	}
	if (!del)
	{   entry [ctr] = entry [ix - 1];
	    ctr++;
	}
	else
	{   if ((highlight_model - 1) == ctr)  {
		highlight_model = 0;
		if (highlight_mode == H_DIFF)  {
		    highlight_mode = H_NONE;
		    move (LINES - 2, 0);
		    printw ("Highlight differences disabled (Model zapped)");
		    Pause (0);
		}
	    }
	    else if ((highlight_model - 1) > ctr)
		highlight_model--;
            file_dirty (entry [ix - 1] -> from_file);
	}
    }
    entry [ctr] = NULL;
    num_entries = ctr;
    disp_all ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

