#ifndef LINT
static char *sccs_sid = "@(#)create.c	1.19 7/22/97 MASE";
#endif

#include "edseq.h"
#include "extern.h"
#include "../lib/faulkn.h"
#ifdef sparc
#include <alloca.h>
#endif

int transl_ignore_gaps = 1;
char *getenv ();

create_locus (current_y, current_x, mult)
int *current_y, *current_x, mult;
{   static char *choices [] = { "All New", "Sequence in Memory",
                                "Import Sequence From Another File", NULL };
    static char *new_names [200];
    static char *fnames [200] = { NULL }, *lnames [200] = { NULL };
    FILE *in_file;
    sq *new, *old;
    char *user, *filen [MAX_FILES], **ptr,
         stemp [200], in_name [200], in_locus [200];
    long tim;
    int indx, model_num, new_position, transl_type, frame;
    static char *transl_menu [] = { "No", "To Three Letter", "To One Letter",
                                    "One AA To Three Letter",
                                    NULL };
    static char *frame_menu [] = { "1", "2", "3", NULL };
    static char *pos_menu [10];

    pos_menu [0] = (char *) alloca (200);
    if (pos_menu [1])   {
        free (pos_menu [1]);
        pos_menu [1] = NULL;
    }
/*  default new position:  set to mult if it is not 1, or
    to the current_y  */
    new_position = (mult == 1) ? *current_y + 1 : mult;
/*  make list of existing files  */
    for (indx = 0; filen [indx] = file_names [indx]; indx++);

    user = getenv ("USER");
    if (!user || !*user)
        user = "UNKNOWN";

    new = (sq *) ecalloc (1, sizeof (sq));
    new -> modified = 1;
    time (&tim);

    switch (win_prompt (stdscr, LINES - 2, "Model new sequence from",
                        NULL, choices, 1, "new_models/"))
    {   case 0:  /*  all new  */
            new -> length = 0;
            new -> allocated = 200;
            new -> seq = ecalloc (205, 1);
            new -> hlite = ecalloc (205, 1);
            sprintf (new -> comments = emalloc (1000),
                     "; Created in MASE on %s;    By:  %s\n", ctime (&tim),
                     user);
            break;
        case 1:  /*  from sequence in memory  */
            sprintf (pos_menu [0], "%d", *current_y + 1);
            do
            {   if (pos_menu [1]) free (pos_menu [1]);
                pos_menu [1] = NULL;
                win_prompt (stdscr, LINES - 2, 
                            "Model sequence", stemp, pos_menu, 0, 
                            "ModelForCreate");
                sscanf (stemp, "%d", &model_num);
                if (model_num > num_entries)
                    model_num = -1;
            }   while (model_num < 0);
            if (model_num)
            {   model_num--;
                old = entry [model_num];
            }
            else
                old = consensus_sequence;

            transl_type = win_prompt (stdscr, LINES - 1, "Translate", NULL,
                                      transl_menu, 1, "AskTranslate/");

            new_position = model_num + 2;  /*  default to after  */
            new -> length = old -> length;
            if (transl_type == 3) {  /* One Letter Protein to Three  */
              new -> length *= 3;
            }

            new -> allocated = new -> length + 1000;
            new -> seq = emalloc (new -> allocated + 10);
            new -> hlite = emalloc (new -> allocated + 10);
            new -> comments = emalloc (500 + strlen (old -> comments));
            sprintf (new -> comments,
                     "; Created in MASE on %s;    By:  %s\n; Copied from locus %s\n",
                     ctime (&tim), user, old -> locus_name);
            strcat (new -> comments, old -> comments);
            if (transl_type < 3) {
              bcopy (old -> seq, new -> seq, new -> length + 10);
              bcopy (old -> hlite, new -> hlite, new -> length + 10);
            }
            if (transl_type)  {
                strcat (new -> comments, "; TRANSLATED\n");
                if (transl_ignore_gaps)
                    strip_seq (new -> seq);
                /* no frame required if we translate from proteins */
                if (transl_type < 3) {
                  frame = win_prompt (stdscr, LINES - 1, "Frame", NULL,
                                      frame_menu, 1, "WhichFrame");
                  /* do_frame_shift (frame, new -> seq);  */
                  for (indx = 0; indx < frame; indx++)
                    new -> seq [indx] = 'X';
                }
                switch (transl_type)  {
                case 1:  /* Three letter  */
                    transl_3_let ((new -> seq) + frame);
                    break;
                case 2:  /* One Letter  */
                    transl_1_let ((new -> seq) + frame);
                    break;
                case 3:
                    transl_aa3_let (old -> seq, new -> seq);
                    break;
                }
                if (transl_ignore_gaps)
                    seq_1_sync (old, new);
                new -> length = strlen (new -> seq);
            }
            for (ptr = new_names; *ptr; ptr++);
            *ptr = old -> locus_name;
            break;
        case 2:  /*  from external file  */
            new_position = *current_y + 2;  /*  default to after current  */
            *in_name = '\0';
            new -> length = 0;
            do  {
                win_prompt (stdscr, LINES - 2,
                            "File containing locus to import",
                            in_name, fnames, 0, "ImportFile");
                in_file = w_open_file (in_name, "r", fnames);
                win_prompt (stdscr, LINES - 2, "Name of locus to import",
                            in_locus, lnames, 0, "ImportLocus");
                while (next_locus (in_file, new -> locus_name) &&
                       strcmp (new -> locus_name, in_locus));
                if (strcmp (new -> locus_name, in_locus))  {
                    move (LINES - 2, 0);
                    printw ("Locus \"%s\" not found in \"%s\"",
                            in_locus, in_name);
                    Pause (0);
                }
                else  {
                    new -> seq = emalloc (new -> allocated = MAX_SEQ);
                    new -> hlite = emalloc (new -> allocated = MAX_SEQ);
                    get_sequence (new -> seq, in_file, &(new -> length),
                                  new -> allocated);
                    move (LINES - 2, 0);
                    for (indx = 0; indx < new -> length; indx++)
                        (new -> hlite) [indx] = '0';
                    (new -> hlite) [indx] = '\0';
                    printw ("%d positions found for \"%s\"", new -> length,
                            new -> locus_name);
                    Pause (0);
                    strcpy (new -> from_file, in_name);
                }
            } while (new -> length == 0);
            new -> comments = emalloc (200);
            sprintf (new -> comments,
                     "; Imported from locus \"%s\" in file \"%s\n;\n",
                     in_locus, in_name);
            for (ptr = new_names; *ptr; ptr++);
            *ptr = new -> locus_name;
            break;
    }
    win_prompt (stdscr, LINES - 2, "Name for locus",
                new -> locus_name, new_names, 0, "name_for_locus");
    do
    {   win_prompt (stdscr, LINES - 2, "File for locus",
                    new -> from_file, filen, 0, "file_for_locus");
        if (!*(new -> from_file))
        {   move (LINES - 2, 0);
            addstr ("Must specify file to store it in");
            Pause (0);
        }
    }   while (!*(new -> from_file));
    sprintf (pos_menu [0], "%d", new_position);
    if (pos_menu [1])
        free (pos_menu [1]);
    pos_menu [1] = NULL;
    win_prompt (stdscr, LINES - 2, "Place new locus AT locus number",
                stemp, pos_menu, 0, "pos_for_locus");
    if (*stemp == '$')
        new_position = num_entries + 1;
    else
        sscanf (stemp, "%d", &new_position);
    new_position--;
    if (new_position < 0)
        new_position = 0;
    if (new_position > num_entries)
        new_position = num_entries;
    new_file (new -> from_file);
    file_dirty (new -> from_file);
    for (indx = num_entries; indx > new_position; indx--)
        entry [indx] = entry [indx - 1];
    entry [new_position] = new;
    num_entries++;
    *current_y = new_position;
    disp_all ();
}

static int transl_init = 0;

transl_3_let (seq)
char *seq;
{   
    if (!transl_init)
        init_transl ();

    while (*seq && seq [1] && seq [2])
    {   trans_3 (seq);
        seq += 3;
    }
    *seq = '\0';
}

transl_1_let (seq)
char *seq;
{   char *seq_transl;

    if (!transl_init)
        init_transl ();

    for (seq_transl = seq; *seq && seq [1] && seq [2]; seq += 3, seq_transl++)
        trans_1 (seq, seq_transl);
    if (*seq)  /*  there was some left over  */
        *(seq_transl++) = 'x';
    *seq_transl = '\0';
    seq_transl [2] = '\0';
}

static int lookup [256];
static char *aa_names [4][4][4] = {
    "Phe", "Ser", "Tyr", "Cys",
    "Phe", "Ser", "Tyr", "Cys",
    "Leu", "Ser", "***", "***",
    "Leu", "Ser", "***", "Trp",

    "Leu", "Pro", "His", "Arg",
    "Leu", "Pro", "His", "Arg",
    "Leu", "Pro", "Gln", "Arg",
    "Leu", "Pro", "Gln", "Arg",

    "Ile", "Thr", "Asn", "Ser",
    "Ile", "Thr", "Asn", "Ser",
    "Ile", "Thr", "Lys", "Arg",
    "Met", "Thr", "Lys", "Arg",

    "Val", "Ala", "Asp", "Gly",
    "Val", "Ala", "Asp", "Gly",
    "Val", "Ala", "Glu", "Gly",
    "Val", "Ala", "Glu", "Gly"
};
static char aa_letters [4][4][4] = {
    'F', 'S', 'Y', 'C',
    'F', 'S', 'Y', 'C',
    'L', 'S', '*', '*',
    'L', 'S', '*', 'W',

    'L', 'P', 'H', 'R',
    'L', 'P', 'H', 'R',
    'L', 'P', 'Q', 'R',
    'L', 'P', 'Q', 'R',

    'I', 'T', 'N', 'S',
    'I', 'T', 'N', 'S',
    'I', 'T', 'K', 'R',
    'M', 'T', 'K', 'R',

    'V', 'A', 'D', 'G',
    'V', 'A', 'D', 'G',
    'V', 'A', 'E', 'G',
    'V', 'A', 'E', 'G'
};

init_transl ()
{   int indx;

    transl_init = 1;
    for (indx = 0; indx < 256; indx++)
        lookup [indx] = -1;

    lookup ['t'] = 0;
    lookup ['T'] = 0;
    lookup ['c'] = 1;
    lookup ['C'] = 1;
    lookup ['A'] = 2;
    lookup ['a'] = 2;
    lookup ['G'] = 3;
    lookup ['g'] = 3;
}


trans_3 (seq)
char *seq;
{   char *new;
    int i1, i2, i3;

    i1 = lookup [seq [0]];
    i2 = lookup [seq [1]];
    i3 = lookup [seq [2]];

/*  note that because of order of table:   0 2 1 indexing  */
    if ((i1 >= 0) && (i2 >= 0) && (i3 >= 0))
        new = aa_names [lookup [seq [0]]]
             [lookup [seq [2]]][lookup [seq [1]]];
    else
        new = "XXX";
    seq [0] = new [0];
    seq [1] = new [1];
    seq [2] = new [2];
}

trans_1 (seq, transl)
char *seq, *transl;
{   char new;
    int i1, i2, i3;

    i1 = lookup [seq [0]];
    i2 = lookup [seq [1]];
    i3 = lookup [seq [2]];

/*  note that because of order of table:   0 2 1 indexing  */
    if ((i1 >= 0) && (i2 >= 0) && (i3 >= 0))
        new = aa_letters [lookup [seq [0]]]
             [lookup [seq [2]]][lookup [seq [1]]];
    else
        new = 'x';
    *transl = new;
}


create_or_load ()
{   static char *list [] = { "Read in a file", "Create New Locus",
                             NULL };
    int y, x;

    switch (win_prompt (stdscr, LINES - 2, "How to start", NULL,
                        list, 1, "HowToStart/"))
    {	case 0:
	    load_one ();
	    break;
        case 1:
            y = x = 0;
	    create_locus (&y, &x, 1);  /*  give dummy args  */
	    break;
    }
}

strip_seq (seq)
char *seq;
{   char *save;

    for (save = seq; *seq; seq++)
      if ((*seq != '.') && (*seq != '-'))
	*(save++) = *seq;
    *save = '\0';
}

do_frame_shift (frame, seq)
int frame;
char *seq;
{   char *tmp;
    int len;

    len = strlen (seq);
    if (!(tmp = (char *) alloca (len + 10)))  {
      move (LINES - 2, 0);
      printw ("ERROR - no mem - no frame shift done, trying to allocate %d bytes",
	      len);
      Pause (1);
    }
    bcopy (seq + frame, tmp, len);
    bcopy (tmp, seq, len);
    
}


static int transl_init_aa3 = 0;

transl_aa3_let (seq, seq_transl)
char *seq, *seq_transl;
{   char *s, *st;
    if (!transl_init_aa3)
        init_transl_aa3 ();

    for (s = seq, st = seq_transl; *s; s++, st += 3)
        trans_aa3 (s, st);
    *st = '\0';
}


static int aa3_lookup [256];
static char *aa3_names [] = {
    "Ala", "Arg", "Asn", "Asp",
    "Asx", "Cys", "Gln", "Glu",
    "Glx", "Gly", "His", "Ile",
    "Leu", "Lys", "Met", "Phe",
    "Pro", "Ser", "Thr", "Trp",
    "Tyr", "Val", "***", "XXX"
};
/*
static char aa3_letters [] = {
     'A', 'R', 'N', 'D',
     'B', 'C', 'Q', 'E',
     'Z', 'G', 'H', 'I',
     'L', 'K', 'M', 'F',
     'P', 'S', 'T', 'W',
     'Y', 'V', '*', 'X'
};
*/

init_transl_aa3 ()
{   int indx;

    transl_init_aa3 = 1;
    for (indx = 0; indx < 256; indx++)
        aa3_lookup [indx] = -1;

    aa3_lookup ['A'] = aa3_lookup ['a'] = 0;
    aa3_lookup ['R'] = aa3_lookup ['r'] = 1;
    aa3_lookup ['N'] = aa3_lookup ['n'] = 2;
    aa3_lookup ['D'] = aa3_lookup ['d'] = 3;
    aa3_lookup ['B'] = aa3_lookup ['b'] = 4;
    aa3_lookup ['C'] = aa3_lookup ['c'] = 5;
    aa3_lookup ['Q'] = aa3_lookup ['q'] = 6;
    aa3_lookup ['E'] = aa3_lookup ['e'] = 7;
    aa3_lookup ['Z'] = aa3_lookup ['z'] = 8;
    aa3_lookup ['G'] = aa3_lookup ['g'] = 9;
    aa3_lookup ['H'] = aa3_lookup ['h'] = 10;
    aa3_lookup ['I'] = aa3_lookup ['i'] = 11;
    aa3_lookup ['L'] = aa3_lookup ['l'] = 12;
    aa3_lookup ['K'] = aa3_lookup ['k'] = 13;
    aa3_lookup ['M'] = aa3_lookup ['m'] = 14;
    aa3_lookup ['F'] = aa3_lookup ['f'] = 15;
    aa3_lookup ['P'] = aa3_lookup ['p'] = 16;
    aa3_lookup ['S'] = aa3_lookup ['s'] = 17;
    aa3_lookup ['T'] = aa3_lookup ['t'] = 18;
    aa3_lookup ['W'] = aa3_lookup ['w'] = 19;
    aa3_lookup ['Y'] = aa3_lookup ['y'] = 20;
    aa3_lookup ['V'] = aa3_lookup ['v'] = 21;
    aa3_lookup ['*'] = 22;
    aa3_lookup ['X'] = aa3_lookup ['x'] = 23;
}

trans_aa3 (seq, transl)
char *seq, *transl;
{   int i;

    i = aa3_lookup [*seq];
    if (i >= 0)
        strcpy(transl, aa3_names [i]);
    else
        strcpy(transl, "XXX");
}
