#ifndef LINT
static char *sccs_sid = "@(#)jurka-m.c	1.21 4/4/89 MASE ";
#endif

#include "edseq.h"
#include "extern.h"
#include "../lib/faulkn.h"

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

int corl_model = -1;

massive_jurka (current_y, current_x, mult)
int *current_x, *current_y, mult;  /*  zero based  */
{   int col_1, col_2, col1_s, col1_e, col2_s, col2_e, n0, n1, n2, 
	n_discarded, *query, score, indx,
	*string_to_numbers (), biggest;
    char stemp [200], *seq, char_1, char_2, cn_1, cn_2,
	*new_string (), fname [30], stemp2 [200];
    static char *col_s_str [2], *col_e_str [2],
	*sq_strings [200];
    float jurka_score;
    FILE *fout;
    static char *fname_list [20] = { "SCREEN", NULL };
    sq *qseq, *model;

    model = NULL;
    if (corl_model > 0)
	model = entry [corl_model - 1];
    if (corl_model == 0)
	model = consensus_sequence;

    fout = NULL;
    win_prompt (stdscr, LINES - 2, "Send output to",
       fname, fname_list, 0, "MJ-Name-Out");
    if (strcmp (fname, "SCREEN"))
        fout = w_open_file (fname, "w", &(fname_list [1]));

    win_prompt (stdscr, LINES - 2, "Correllate sequences",
	stemp, sq_strings, 0, "MJ-Which-Seq");
    if (!(query = string_to_numbers (stemp)))
	return;

    sprintf (stemp, "%d", *current_x + 1);
    col_s_str [0] = new_string (stemp);
    col_e_str [1] = NULL;

    sprintf (stemp, "%d", *current_x + 1 + mult);
    col_e_str [0] = new_string (stemp);
    col_e_str [1] = NULL;

    win_prompt (stdscr, LINES - 2, "Column 1 (start stop)",
	stemp, col_s_str, 0, "MJ-Col-1");
    col1_s = col1_e = 0;
    sscanf (stemp, "%d%d", &col1_s, &col1_e);
    if (!col1_s)
	return;
    if (!col1_e)
	col1_e = col1_s;
    col1_s--; col1_e--;

    win_prompt (stdscr, LINES - 2, "Column 2 (start stop)",
	stemp, col_s_str, 0, "MJ-Col-2");
    col2_s = col2_e = 0;
    sscanf (stemp, "%d%d", &col2_s, &col2_e);
    if (!col2_s)
	return;
    if (!col2_e)
	col2_e = col2_s;
    col2_s--; col2_e--;

clean_bottom ();
for (col_1 = col1_s; col_1 <= col1_e; col_1++)
{   if (fout)
    {   move (LINES - 1, 0);
	clrtoeol ();
	printw ("Column %d", col_1 + 1);
	refresh ();
    }
    for (col_2 = col2_s; col_2 <= col2_e; col_2++)
    {	if (col_2 <= col_1)
	    continue;
	/*  biggest = (col_1 > col_2) ? col_1 : col_2;  */
	biggest = col_2;
	n_discarded = n2 = n1 = 0;
    /*  trick so we can start at the beginning  */
	n0 = -1;
	if (model)
	{   char_1 = (model -> seq) [col_1];
	    char_2 = (model -> seq) [col_2];
	    n0 = 0;  /*  no need to trick it  */
	}
	else
	    char_1 = char_2 = '\0';  
	for (indx = 0; query [indx] >= 0; indx++)
	{   if (query [indx])
	        qseq = entry [query [indx] - 1];
	    else
	        qseq = consensus_sequence;
            if (qseq -> length > biggest)
	    {   seq = qseq -> seq;
		cn_1 = seq [col_1]; cn_2 = seq [col_2];
		if ((cn_1 != '-') && (cn_2 != '-'))
		{   seq = qseq -> seq;
		    score = 0;
		    if (char_1 == seq [col_1]) score++;
		    if (char_2 == seq [col_2]) score++;
		    if (!model)
		    {   char_1 = seq [col_1];
			char_2 = seq [col_2];
		    }
		    switch (score)
		    {   case 0:
			    n0++; break;
			case 1:
			    n1++; break;
			case 2:
			    n2++; break;
		    }
		}
		else
		{   if (n0 == -1)
		        n0 = 0;    /* HACK HACK HACK  ! ! ! */
		    n_discarded++;
		}
	    }
	}
	if (!fout)
        {   move (LINES - 2, 0);
	    sprintf (stemp2,
               "Col %d x %d: Both ch %d; One ch %d; None ch %d; Discrd. %d: ",
	             col_1 + 1, col_2 + 1, n0, n1, n2, n_discarded);
	    addstr (stemp2);
	    clrtoeol ();
	}
	jurka2 (n0, n1, n2, &jurka_score);
	if (!fout)
	{   printw ("Score %6.4f", jurka_score);
	    refresh ();
	}
	if (jurka_score <= massive_jurka_threshold)
        {   if (!fout)
		Pause (0);
	    else
		fprintf (fout, "%7.4f %4d %4d (%3d %3d %3d)\n", 
		    jurka_score,
		    col_1 + 1, col_2 + 1,
		    n0, n1, n2);
	}
    }
    if (fout)
        fflush (fout);
}
    if (fout)
        fclose (fout);
    free (query);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

