#ifndef LINT
static char *sccs_sid = "@(#)mouse.c	1.10 4/4/89 MASE";
#endif

#include "edseq.h"
#include "extern.h"
/*  SUNTOOLS interface for MASE
    Intended to run under ``EMACSTOOL'' to handle 
	the mouse and function buttons
*/

int mouse_mark_x = -1, mouse_mark_y = -1;


int mouse_open_rect (), mouse_close_rect (), set_mouse_mark ();
int (*(mouse_function_pointers [256])) ();

init_mouse ()
{   int indx;
    
    for (indx = 0; indx < 256; indx++)
	mouse_function_pointers [indx] = null_command;
    
    mouse_function_pointers [2] = x_ins;  
	/*  left press  */
    mouse_function_pointers [4] = x_del;  
	/*  right press  */
    mouse_function_pointers [10] = set_mouse_mark;  
	/*  shift middle press  */
    mouse_function_pointers [138] = mouse_open_rect; 
	/*  shift middle release  */
    mouse_function_pointers [12] = set_mouse_mark;  
	/*  shift right press  */
    mouse_function_pointers [140] = mouse_close_rect; 
	/*  shift right release  */

}

mit_mouse (y, x, mult)
int *y, *x, mult;
{   int button, col, row;

    button = getchar () - 040; 
    col = getchar () - 041;
    row = getchar () - 041;
    switch (button)  {
	case 0:
	    button = 1;
	    break;
	case 1:
	    button = 2;
	    break;
	case 2:
	    button = 4;
	    break;
	default:
	    button = -1;
	    break;
    }
    if (button == -1)  {
	move (LINES - 2, 0);
	printw ("UNKNOWN MOUSE BUTTON");
	Pause (0);
    }
    if (mouse_position (y, x,  row, col))
    {   (*mouse_function_pointers [button]) (y, x, mult);
    }
}


mouse (y, x, mult)
int *y, *x, mult;
{   int chr;

    chr = wgetch (stdscr);
    switch (chr)
    {   case '\0':
	    mouse_mouse (y, x, mult);
	    break;
	case '*':
	    mouse_function_key (y, x, mult);
	    break;
	default:
	    move (LINES - 2, 0);
	    addstr ("ERROR:  unknown mouse function");
	    Pause (0);
	    break;
    }
}

mouse_function_key (y, x, mult)
int *y, *x, mult;
{
}

mouse_mouse (y, x, mult)
int *y, *x, mult;
{   char chr;
    char buf [200], *ptr;
    int mous_x, mous_y, mouse_b;

    ptr = buf;
    do
    {   chr = *ptr = wgetch (stdscr);
	ptr++;
    }   while (chr != '\n');
    *ptr = '\0';
    if (sscanf (buf, "(%d %d %d)\n", &mouse_b, &mous_x, &mous_y)
	!= 3)
    {   move (LINES - 2, 0);
	addstr ("Bad mouse button");
	Pause (0);
	return;
    }
    if (mouse_position (y, x,  mous_y, mous_x))
       (*mouse_function_pointers [mouse_b]) (y, x, mult);
    return;
}



mouse_position (cury, curx,  mouse__y, mouse__x)
int *curx, *cury, mouse__y, mouse__x;
{   int status, max_val;
    
    status = 1;

    if ((mouse__y > LINES - 2) || ((mouse__y > LINES - 3) &&
	(mouse__x > 2)))
    {   max_val = longest_seq ();
	max_val *= mouse__x;
	max_val /= (COLS - 1);
	*curx = max_val;
	return (0);
    }
    if (mouse__x < 3)  /*  set vert pos  */
    {   max_val = count_entries ();
	max_val *= mouse__y;
	max_val /= (LINES - 2);  /*  can't get to bottom line  */
	*cury = max_val;
	return (0);
    }
    mouse__y--;  /*  subtract the line at the top  */
    if (mouse__y < 0)  /*  mouse off the top  */
	return (0);
    if (mouse__y >= num_per_win)  /*  mouse off bottom  */
        return (0);

    *cury = mouse__y + top_seq;

    mouse__x -= 27;  /* subtract locus names  */
    if (mouse__x < 0)  /*  cursor was in locus names  */
	return (0);

    if (mouse__x < seq_width)  /*  cursor in first window  */
    {   *curx = start_1 + mouse__x;
	return (status);
    }
    mouse__x -= (seq_width + 1);  /* left win plus gap  */
    if (mouse__x < 0)  /*  cursor bet windows  */
	return (0);  /*  do nothing if between  */
    if (mouse__x > seq_width)  /*  in right margin  */
	return (0);
    *curx = start_2 + mouse__x;
    return (status);
}

longest_seq ()
{   register int longest, indx, this;

    longest = 0;
    for (indx = 0; entry [indx]; indx++)
    {   this = entry [indx] -> length;
	if (this > longest)
	    longest = this;
    }
    return (longest);
}

count_entries ()
{   register indx;
    for (indx = 0; entry [indx]; indx++);
    return (indx);
}


mouse_open_rect (cury, curx, mult)
int *cury, *curx, mult;
/*  open rectangle between mark 1 and current cursor position  */
{   int indx, num_to_insert, where_to_insert, start_row, end_row;

    if ((mouse_mark_x == -1) ||(mouse_mark_y == -1))
        return;  /*  watch out - check for mouse mark not set  */
    if (*curx < mouse_mark_x)
    {   num_to_insert = mouse_mark_x - *curx + 1;
	where_to_insert = *curx;
    }
    else
    {   num_to_insert = *curx - mouse_mark_x + 1;
	where_to_insert = mouse_mark_x;
    }
    if (*cury < mouse_mark_y)
    {   start_row = *cury;
	end_row = mouse_mark_y;
    }
    else
    {   start_row = mouse_mark_y;
	end_row = *cury;
    }
    for (indx = start_row; indx <= end_row; indx++)
        ins_1 (indx, where_to_insert, num_to_insert, '-');
     
    disp_all ();
    zap_mouse_mark ();
}


mouse_close_rect (cury, curx, mult)
int *cury, *curx, mult;
{   int num_to_delete, where_to_delete, indx, start_row, end_row;
    int list [NUMBER_SEQ + 3], counter;
    int *new_list, *verify_delete ();

    bzero ((char *) list, NUMBER_SEQ * sizeof (int));
    if ((mouse_mark_x == -1) ||(mouse_mark_y == -1))
        return;  /*  watch out - check for mouse mark not set  */

    if (*curx < mouse_mark_x)
    {   num_to_delete = mouse_mark_x - *curx + 1;
	where_to_delete = *curx;
    }
    else
    {   num_to_delete = *curx - mouse_mark_x + 1;
	where_to_delete = mouse_mark_x;
    }
    if (*cury < mouse_mark_y)
    {   start_row = *cury;
	end_row = mouse_mark_y;
    }
    else
    {   start_row = mouse_mark_y;
	end_row = *cury;
    }
/*  make the list  */
    for (indx = start_row, counter = 0; indx <= end_row; 
	indx++, counter++)
    {   list [counter] = indx + 1;  /*  other routines want 1 added */
    }
    
    if (protect)
    {   new_list = 
	    verify_delete (list, where_to_delete + 1, num_to_delete);
	if (new_list)
	{   protect = 0;
	    delete_cols (new_list, where_to_delete + 1, num_to_delete);
	    protect = 1;
	}
    }
    else
	delete_cols (list, where_to_delete + 1, num_to_delete);
    disp_all ();
    zap_mouse_mark ();
}


zap_mouse_mark ()
/*  mark the mouse_mark as invalid  */
{   mouse_mark_x = mouse_mark_y = -1;
}


set_mouse_mark (cury, curx, mult)
int *cury, *curx, mult;
/*  store the current position in the mouse mark  */
{
    mouse_mark_x = *curx;
    mouse_mark_y = *cury;
}

