//changed usg to linux // Mike Jurka 2003

#ifndef LINT
static char *sccs_sid = "@(#)similarity.c	1.6 3/20/89 MASE";
#endif

#include "edseq.h"
#include "extern.h"
#include "../lib/faulkn.h"

int sim_discard_gaps = 0;

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */


do_similarity (current_y)
int *current_y;  /*  zero based  */
{   int *query, *num_list, *string_to_numbers (), start, stop;
    char stemp [200];
    static char *sq_strings [2000], *q_strings [2000],
	*start_strings [200] = { "1" },
	*stop_strings [200] = { "999999" };

    i_d_doit (sq_strings, *current_y + 1);

    win_prompt (stdscr, LINES - 2, "Query sequences",
	stemp, sq_strings, 0, "Range");
    if (!(query = string_to_numbers (stemp)))
        return;
    win_prompt (stdscr, LINES - 1, "    Run against which sequences",
	stemp, q_strings, 0, "Range");
    if (!(num_list = string_to_numbers (stemp)))
	return;
    clean_bottom ();
    win_prompt (stdscr, LINES - 2, "Start of region to compare",
	stemp, start_strings, 0, "Similarity-Region-Start");
    sscanf (stemp, "%d", &start);
    win_prompt (stdscr, LINES - 1, "    End of region to compare",
	stemp, stop_strings, 0, "Similarity-Region-End");
    sscanf (stemp, "%d", &stop);

    display_similarity (query, num_list, start, stop);
    free (num_list);
    free (query);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

float similarity (query, tst, start, stop)
/*  return similarity value between sequence #query and #test  */
int query, tst, start, stop;
{   register int length;
    register float sum;
    register char *sq_1, *sq_2;
    sq *sqt;

/*    if ((entry [query] -> length <= start) || 
	(entry [tst] -> length <= start))
	return (0.0);
*/
    if (query)
        sqt = entry [query - 1];
    else
        sqt = consensus_sequence;
    if (sqt -> length <= start)
        return (0.0);
    sq_1 = &((sqt -> seq) [start]);
    if (tst)
        sqt = entry [tst - 1];
    else
        sqt = consensus_sequence;
    sq_2 = &((sqt -> seq) [start]);
    if (sqt -> length <= start)
        return (0.0);
/*    sq_2 = entry [tst] -> seq;  */

    sum = 0.0;
    length = 0;
    do  {
      if (!(sim_discard_gaps && (*sq_1 == '-') && (*sq_2 == '-')))  {
	sum += score_matrix [*sq_1][*sq_2];
	length++;
      }
      sq_1++; sq_2++;
      start ++;
    }   while (*sq_1 && *sq_2 && (start <= stop));
    return (length ? sum / (float) length : 0);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

display_similarity (query, library, start, stop)
/*  display similarity scores in a manner befitting number  */
int *query, *library, start, stop;
{   int sc_len, o_typ, *ltemp,
	n_this, n_all;
    float sum_this, sum_all, hom_val;
    char stemp [200], stemp2 [200];
    sq *tmp1, *tmp2;
    static char *out_hist [300] = { "HPLOT", "SCREEN", NULL };
    FILE *fout;
    float similarity ();

    clean_bottom ();
    win_prompt (stdscr, LINES - 2, "Output to file",
	stemp, out_hist, 0, "Similarity-Output-File");

    clean_bottom ();
    strcpy (stemp2, stemp);
    uc_string (stemp2);
    o_typ = decode (stemp2, "HPLOT", "SCREEN", NULL);
    if (o_typ != 1)
    {   if (o_typ == 0)
	{   fout = popen ("hplot - \"MASE scores\" 1", "w");
	    strcpy (stemp, "hplot");
	}
	else
	   fout = w_open_file (stemp, "w", &(out_hist [2]));
	if (fout == NULL)
	{   move (LINES - 2, 0);
	    printw ("Could not write to \"%s\"", stemp);
	    Pause (0);
	    return;
	}
    }
    else
	fout = stdout;

#ifndef linux
    if (HO) fputs (HO, stdout);
    if (CL) fputs (CL, stdout);
#endif

    n_all = 0;
    sum_all = 0.0;
    sc_len = LINES - 2;
    for (; *query >= 0; query++)
    {   if (*query)
            tmp1 = entry [*query - 1];
	else
	    tmp1 = consensus_sequence;
	n_this = 0;
	sum_this = 0.0;
	for (ltemp = library; *ltemp >= 0; ltemp++)
	{   if (*ltemp)
	        tmp2 = entry [*ltemp - 1];
	    else
	        tmp2 = consensus_sequence;
	    if (!ignore_selves_in_similarity || (*query != *ltemp))
	    {	hom_val = similarity (*query, *ltemp, start - 1,
		        stop - 1);
		sum_this += hom_val;
		n_this++;
		fprintf (fout, 
		    "%10.5f%10s %s (#%d, l=%d) X %s (#%d, l=%d)\n",
		    hom_val, "",
		    tmp1 -> locus_name, *query, tmp1 -> length,
		    tmp2 -> locus_name, *ltemp, tmp2 -> length);
		sc_len --;
		if ((o_typ == 1) && (sc_len <= 0))
		{   sc_len = LINES - 2;
		    printf ("Hit <CR> to continue -> ");
		    fflush (stdout);
		    fgets (stemp, 199, stdin);
#ifndef linux
		    if (HO) fputs (HO, stdout);
		    if (CL) fputs (CL, stdout);
#endif
		}
	    }
	}
	if (o_typ != 0)
	    fprintf (fout, 
		"Average for %s (#%d, l=%d) = %10.5f / %d = %10.5f\n",
		tmp1 -> locus_name, *query, tmp1 -> length,
		sum_this, n_this,
		n_this ? sum_this / (float )n_this : 0.0);
	sc_len--;
	if ((o_typ == 1) && (sc_len <= 2))
	{   sc_len = LINES - 2;
	    printf ("Hit <CR> to continue -> ");
	    fflush (stdout);
	    fgets (stemp, 199, stdin);
#ifndef linux
	    if (HO) fputs (HO, stdout);
	    if (CL) fputs (CL, stdout);
#endif
	}
	n_all += n_this;
	sum_all += sum_this;
	if (o_typ != 0)
	    fprintf (fout, "\n");
	sc_len--;
    }
    if (o_typ != 0)
	fprintf (fout, 
	    "Average for all comparisons = %10.5f / %d = %10.5f\n",
	    sum_this, n_this,
	    n_all ? sum_all / (float )n_all : 0.0);

    if (o_typ <= 0)
        pclose (fout);
/*  pclose or fclose ? ? ? ?  need to wait for flushed output  */

    printf ("Hit <CR> to continue -> ");
    fflush (stdout);
    fgets (stemp, 199, stdin);
#ifndef linux
    if (HO) fputs (HO, stdout);
    if (CE) fputs (CE, stdout);
    if (CL) fputs (CL, stdout);
#endif
    wrefresh (curscr);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   


do_matrix ()
/*  read in a new matrix for similarity reading  */
{   char stemp [200];
    static char *old [2000] = { "DEFAULT" };
    
    win_prompt (stdscr, LINES - 2, "File containing scores matri",
	stemp, old, 0, "Matrix-File");
    read_matrix_file (stemp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

read_matrix_file (fname)
char *fname;
{   float score;
    FILE *finp;
    char cset_1 [100], cset_2 [100], *cp1, *cp2, stemp [200];
    int c1_min, c1_max, c2_min, c2_max, c1, c2;
    static char *hist [300];

    if (strcmp (fname, "DEFAULT") == 0)
    {   default_matrix ();
	return;
    }
    if ((*fname == '\0') || ((finp = w_open_file (fname, "r", hist)) 
	== NULL))
    {   move (LINES - 2, 0);
	clrtoeol ();
	printw ("Could not read matrix file \"%s\"", fname);
	Pause (0);
	return;
    }
/*  arrive here if we are to read in the file  */
    default_matrix ();
    /*  set to all default values  */
    while (fgets (stemp, 200, finp))
    {   if ((*stemp != '\0') && (*stemp != ';') && (*stemp != '\n'))
	{    sscanf (stemp, "%f%s%s", &score, cset_1, cset_2);
	    for (cp1 = cset_1; (c1 = *cp1) != '\0'; cp1++)
		for (cp2 = cset_2; (c2 = *cp2) != '\0'; cp2++)
		{   if (c1 == '*')
		    {   c1_min = 0; c1_max = 128;
		    }
		    else
		    {   c1_min = c1; c1_max = c1 + 1;
		    }
		    if (c2 == '*')
		    {   c2_min = 0; c2_max = 128;
		    }
		    else
		    {   c2_min = c2; c2_max = c2 + 1;
		    }
		    for (c1 = c1_min; c1 < c1_max; c1++)
		    {   if (*cp2 == '&')
			{   c2_min = c1; c2_max = c1 + 1;
			}
			for (c2 = c2_min; c2 < c2_max; c2++)
			{   score_matrix [c1][c2] = score;
			    score_matrix [c2][c1] = score;
			}
		    }
		}
	    }
    }
    fclose (finp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

