
#ifndef LINT
static char *sccs_sid = "@(#)undo.c	1.5 2/3/95 MASE";
#endif

#include "edseq.h"
#include "extern.h"

#include "undo.h"

FILE *undo_file = NULL;

undo **undo_stack = NULL, **undo_top_stack = NULL;
char *undo_strings [UNDO_NUMBER];

push_undo (ent)
undo *ent;
{   undo *NewUndo;

    if (undo_file)  {
    }
    NewUndo = (undo *) emalloc (sizeof (undo));
    bcopy (ent, NewUndo, sizeof (undo));
    if (!undo_stack)
	init_undo ();
    *(undo_top_stack++) = NewUndo;
    if ((undo_top_stack - undo_stack) >= MAX_UNDO)
	undo_shift_stack ();
}


init_undo ()
{   
    undo_stack = undo_top_stack = 
	(undo **) ecalloc (MAX_UNDO + 10, sizeof (undo *));

    undo_strings [UNDO_INS] = "Ins";
    undo_strings [UNDO_DEL] = "Del";
    undo_strings [UNDO_MOVE_POS] = "Move_Pos";
    undo_strings [UNDO_MOVE_FILE] = "Move_File";
    undo_strings [UNDO_CREATE] = "Create";
    undo_strings [UNDO_ZAP] = "Zap";

}


undo_shift_stack ()
{   int current, adjust_by, indx;

    move (LINES - 2, 0);
    printw ("WARNING - undo stack overflowed, some undo information");
    printw (" lost");
    clrtoeol ();
    refresh(); /* (PWK) */
    /* Pause (0); *//* (PWK) */
    current = undo_top_stack - undo_stack;
    adjust_by = MAX_UNDO / 2;
    for (indx = 0; indx <= (current - adjust_by); indx++)
	undo_stack [indx] = undo_stack [indx + adjust_by];
    current -= adjust_by;
    undo_top_stack = &(undo_stack [current]);
}

Undo (y, x)
int *y, *x;
{   undo *this;
    int indx, i1, i2;
    sq *ent;
    char *seq, *hlite;

    if (!undo_stack || (undo_top_stack <= undo_stack))  {
        move (LINES - 2, 0);
	printw ("Nothing to undo");
	Pause (0);
	return;
    }
  
    this = *(--undo_top_stack);
    ent = entry [this -> number];
    seq = ent -> seq; hlite = ent -> hlite;

    move (LINES - 2, 0);
    
    switch (this -> Type)  {
	case UNDO_DEL:
	    printw ("Delete %d positions from locus %s after position %d",
		this -> s.U_DEL.num_char + 1, ent -> locus_name,
		this -> s.U_DEL.pos);
 	    addch ('(');
	    for (indx = 0; (indx < 10) &&
		(indx < this -> s.U_DEL.num_char); indx++)
		addch (this -> s.U_DEL.chars [indx]);
	    addch (')');
	    switch (confirm ())  {
	        case 1:
	            return;
		    break;
	        case 0:
		    *y = this -> number;
		    *y = this -> s.U_DEL.pos;
		    i2 = this -> s.U_DEL.num_char;
		    ent -> length += i2;
		    for (i1 = ent -> length; i1 > this -> s.U_DEL.pos; i1--)  {
		      hlite [i1] = hlite [i1 - i2];
		      seq [i1] = seq [i1 - i2];

		    }
		    for (i1 = 0; i1 < i2; i1++)  {
		      seq [(this -> s.U_DEL.pos) + i1] =
			this -> s.U_DEL.chars [i1];
		      hlite [(this -> s.U_DEL.pos) + i1] =
			this -> s.U_DEL.hchars [i1];
		    }
		    if (undo_file)  {
		      fprintf (undo_file, "INS %d %d %d %s\n",
			       this -> number, this -> s.U_DEL.pos,
			       this -> s.U_DEL.num_char,
			       this -> s.U_DEL.chars);
		      fflush (undo_file);
		    }
	    }
	    break;
	case UNDO_INS:
	    printw ("Insert %d \'%c\' into locus %s after position %d",
		this -> s.U_INS.num_char, this -> s.U_INS.chr,
		    ent -> locus_name, this -> s.U_DEL.pos);
	    switch (confirm ())  {
	        case 1:
	            return;
		    break;
	        case 0:
		    *y = this -> number;
		    *y = this -> s.U_INS.pos;
		    i2 = this -> s.U_INS.num_char;
		    ent -> length -= i2;
		    for (i1 = this -> s.U_INS.pos; i1 < ent -> length; i1++)  {
		      hlite [i1] = hlite [i1 + i2];
		      seq [i1] = seq [i1 + i2];

		    }
		    if (undo_file)  {
		      fprintf (undo_file, "DEL %d %d %d\n",
			       this -> number, this -> s.U_DEL.pos,
			       this -> s.U_DEL.num_char);
		      fflush (undo_file);
		    }
	    }
	    break;
	case UNDO_MOVE_POS:
	    printw ("Moved sequence %d (%s) to position %d",
		    this -> number + 1,
		    entry [this -> s.U_MOVE_POS.number_to] -> locus_name,
		    this -> s.U_MOVE_POS.number_to);
	    switch (confirm ())  {
	        case 1:
	            return;
		    break;
	        case 0:
		    *y = this -> s.U_MOVE_POS.number_to;
		    ent = entry [this -> s.U_MOVE_POS.number_to];
		    for (i1 = this -> s.U_MOVE_POS.number_to; i1 < num_entries;
			 i1++)
		      entry [i1] = entry [i1 + 1];
		    for (i1 = num_entries; i1 >= this -> number; i1--)
		      entry [i1] = entry [i1 - 1];
		    entry [this -> number] = ent;
		    if (undo_file)  {
		      fprintf (undo_file, "MOVE-POS %d %d\n",
			       this -> s.U_MOVE_POS.number_to, this -> number);
		      fflush (undo_file);
		    }
	    }

	    break;
	case UNDO_MOVE_FILE:
	    printw ("Moved locus %d (%s) from file %s to file %s",
		    this -> number, ent -> locus_name,
		    this -> s.U_MOVE_FILE.from_file,
		    ent -> from_file);
	    switch (confirm ())  {
	        case 1:
	            return;
		    break;
	        case 0:
		    *y = this -> number;
		    strcpy (ent -> from_file, this -> s.U_MOVE_FILE.from_file);
		    if (undo_file)  {
		      fprintf (undo_file, "MOVE_FILE %d %s\n",
			       this -> number, ent -> from_file);
		      fflush (undo_file);
		    }
	    }
	    break;
	case UNDO_CREATE:
	    printw ("Created locus %d (%s)", this -> number + 1,
		    ent -> locus_name);
	    switch (confirm ())  {
	        case 1:
	            return;
		    break;
	        case 0:
		    for (i1 = this -> number; i1 < num_entries; i1++)
		      entry [i1] = entry [i1 + 1];
		    i2 = this -> s.U_INS.num_char;
		    ent -> length -= i2;
		    for (i1 = this -> s.U_INS.pos; i1 < ent -> length; i1++)  {
		      hlite [i1] = hlite [i1 + i2];
		      seq [i1] = seq [i1 + i2];

		    }
		    if (undo_file)  {
		      fprintf (undo_file, "DEL %d %d %d\n",
			       this -> number, this -> s.U_DEL.pos,
			       this -> s.U_DEL.num_char);
		      fflush (undo_file);
		    }
	    }
	    break;
	case UNDO_ZAP:
	    printw ("Unzap sequence %d (\"%s\")", this -> number + 1,
		    this -> s.U_ZAP.Entry -> locus_name);
	    switch (confirm ())  {
	        case 1:
	            return;
		    break;
	        case 0:
		    *y = this -> number;
		    for (indx = num_entries; indx >= this -> number; indx--)
		         entry [indx] = entry [indx - 1];
		    entry [this -> number] = this -> s.U_ZAP.Entry;
/*		    if (undo-fil) {
 		      fprintf (undo_file, "DEL %d %d %d\n",
			       this -> number, this -> s.U_DEL.pos,
			       this -> s.U_DEL.num_char);
		      fflush (undo_file);
		    }
*/
	    }
	    break;
    }
    disp_all ();
}


confirm ()
{   static char *answers [] = { "Apply", "Discard", NULL };
    char resp [200];

    return (win_prompt (stdscr, LINES - 1, "UNDO", resp, answers, 1,
			"ApplyUndo/"));
}

